=== debian/changelog ===
datum-gateway (0.4.0~beta-1) experimental; urgency=low

  * Initial release. Closes: #1108258

 -- Léo Haf <leo@haf.ovh>  Mon, 03 Nov 2025 11:21:42 +0000
