=== debian/control ===
Source: datum-gateway
Maintainer: Léo Haf <leo@haf.ovh>
Section: net
Priority: optional
Standards-Version: 4.7.2
Homepage: https://ocean.xyz
Vcs-Git: https://salsa.debian.org/cryptocoin-team/datum-gateway.git
Vcs-Browser: https://salsa.debian.org/cryptocoin-team/datum-gateway
Build-Depends: debhelper-compat (= 13),
 cmake,
 pkgconf,
 libjansson-dev,
 libmicrohttpd-dev,
 libsodium-dev,
 libcurl4-openssl-dev,
 po-debconf

Package: datum-gateway
Architecture: amd64 arm64
Depends: ${shlibs:Depends},
 ${misc:Depends},
 bitcoin-knots,
 pwgen,
 jq,
 debconf
Description: Decentralized Alternative Templates for Universal Mining
 The DATUM Gateway is a server providing solo mining capabilities for Bitcoin
 miners, including both non-pooled and pooled solo mining using the new DATUM
 protocol.
